New to Kendo UI for Angular? Start a free 30-day trial

Data Binding

The TreeView provides core settings for data binding scenarios and enables you to work with various types of data.

Basics

The TreeView exposes the following core data-binding options:

  • nodes (field)—Renders the collection which will be visualized as a top-most level.
  • textField (field)—Determines the node field that will be displayed.
  • hasChildren (function)—Determines if a given node has children.
  • children (function)—Supplies the child node based on the provided parent.
   import { Component } from '@angular/core';
   import { Observable, of } from 'rxjs';

   @Component({
       selector: 'my-app',
       template: `
       <kendo-treeview
           kendoTreeViewExpandable <-- Manages the expand-collapse state.

           [nodes]="data" <-- The nodes are in the data field of the host component.
           textField="text" <-- The text field of the node will be displayed.

           [children]="fetchChildren"  <-- The fetchChildren function will provide the child nodes.
           [hasChildren]="hasChildren" <-- Use the fetchChildren function to check if a node has children.
        >
       </kendo-treeview>
   `
   })
   export class AppComponent {

       public data: any[] = [{
               text: "Furniture", items: [
                   { text: "Tables & Chairs" },
                   { text: "Sofas" },
                   { text: "Occasional Furniture" }
               ]
           }, {
               text: "Decor", items: [
                   { text: "Bed Linen" },
                   { text: "Curtains & Blinds" },
                   { text: "Carpets" }
               ]
           }
       ];

       public fetchChildren(node: any): Observable<any[]> {
           //Return the items collection of the parent node as children.
           return of(node.items);
       }

       public hasChildren(node: any): boolean {
           //Check if the parent node has children.
           return node.items && node.items.length > 0;
       }
   }

Hierarchical Data Binding

To render a hierarchical set of data, implement the children and hasChildren functions.

Example
View Source
Change Theme:

Built-in Directives

The built-in data-binding directives provide specialized implementations of required callbacks and events, simplify data binding, minimize boilerplate code, and support flat or heterogeneous data.

The TreeView supports the following built-in directives:

  • kendoTreeViewHierarchyBinding—Handles the binding to hierarchical data.
  • kendoTreeViewFlatDataBinding—Handles the binding to flat data by mapping the data to a hierarchical structure and by using the configured parent-child relation.

Types of Data

The TreeView provides options for binding it to:

Local Heterogeneous Data

The following example demonstrates how to use kendoTreeViewHierarchyBinding to bind the TreeView to local data. The childrenField option indicates which field of the parent node contains the children. Setting the textField to an array allows you to have separate field names for each level.

Example
View Source
Change Theme:
{% embed_file shared/main.ts %}

Remote Heterogeneous Data

The following example demonstrates how to fetch remote data and bind the TreeView to it. While the function that is assigned to the hasChildren setting signals if the given parent node has child nodes, the children option fetches and supplies the data for the child nodes.

Example
View Source
Change Theme:

Flat Data

The following example demonstrates how to use kendoTreeViewFlatDataBinding to bind the TreeView to flat data. By using the idField and parentIdField to configure the relation between parent and child nodes, you can convert flat data to hierarchal structure.

Example
View Source
Change Theme:

New to KendoReactStart a free 30-day trial

Data Binding
Premium

The TreeView enables you to work with various types of data.

Basics

To bind the TreeView to data:

  1. Add children items to an item with an items field.
  2. Configure the data property.
Change Theme
Theme
Loading ...

Item Fields

By default, the TreeView provides the following fields for its items:

  • text—The string representation of the item.
  • items—The children of the item.
  • expanded—If set to true, expands the item.
  • selected—If set to true, selects the item.
  • disabled—If set to true, disables the item.
  • checked—If set to true, checks the item.
  • checkIndeterminate—If set to true, applies an indeterminate check to the item.
  • hasChildren—If set to true, notifies the TreeView that the item has children even if they are not initially passed. Used for implementing the load-on-demand feature.

Apart form items, you can replace each of the default TreeView fields with custom ones. To include your own fields, set the corresponding TreeView property to the name of the custom field. The TreeView also supports the nesting of its item fields.

jsx
const tree = [
    {
        data: { text: 'Furniture' },
        opened: true,
        items: [
            { data: { text: 'Tables & Chairs' } },
            { data: { text: 'Sofas' } },
            { data: { text: 'Occasional Furniture' } }
        ]
    },
    {
        data: { text: 'Decor' },
        opened: true,
        items: [{ data: { text: 'Bed Linen' } }, { data: { text: 'Curtains & Blinds' } }, { data: { text: 'Carpets' } }]
    }
];

class App extends React.Component {
    render() {
        return (
            <TreeView
                data={tree}
                textField="data.text"
                expandIcons={true}
                expandField="opened"
                onExpandChange={this.onExpandChange}
            />
        );
    }
    onExpandChange = (event) => {
        event.item.opened = !event.item.opened;
        this.forceUpdate();
    };
}

ReactDOM.render(<App />, document.querySelector('my-app'));

Loading Data on Demand

The following example demonstrates how to fetch remote data and bind the TreeView to it.

To implement the load-on-demand feature:

  1. Set the hasChildren field of the root items.
  2. Provide their children afterwards.
jsx
const baseUrl = 'https://odatasampleservices.azurewebsites.net/V4/Northwind/Northwind.svc/Categories';
const requestInit = { method: 'GET', accept: 'application/json', headers: [] };

class App extends React.Component {
    state = { data: [] };

    render() {
        return <TreeView data={this.state.data} expandIcons={true} onExpandChange={this.onExpandChange} />;
    }

    componentDidMount() {
        fetch(baseUrl, requestInit)
            .then((response) => response.json())
            .then((json) => {
                const data = json.value.map(({ CategoryID, CategoryName }) => {
                    return { text: CategoryName, id: CategoryID, hasChildren: true };
                });

                this.setState({ data });
            });
    }

    onExpandChange = (event) => {
        const categoryIndex = Number(event.itemHierarchicalIndex);
        const { data, category } = this.copyDataAndCategory(categoryIndex);
        category.expanded = !category.expanded;

        this.setState({ data });

        !category.items && this.loadProducts(categoryIndex, category.id);
    };

    loadProducts(categoryIndex, categoryId) {
        fetch(`${baseUrl}(${categoryId})/Products`, requestInit)
            .then((response) => response.json())
            .then((json) => {
                const { data, category } = this.copyDataAndCategory(categoryIndex);
                category.items = json.value.map(({ ProductName }) => {
                    return { text: ProductName };
                });

                this.setState({ data });
            });
    }

    copyDataAndCategory(categoryIndex) {
        const data = this.state.data.slice();
        const category = (data[categoryIndex] = { ...data[categoryIndex] });

        return { data, category };
    }
}

ReactDOM.render(<App />, document.querySelector('my-app'));